Direct web services
Summarize
Summary of Direct Web Services
Direct web services in ServiceNow provide SOAP-based APIs for any table in the system, given proper access controls are set. They support document style literal XML SOAP messages and enable customers to interact with ServiceNow data programmatically. The WSDL description for a specific table's web service can be retrieved by accessing the table’s relative URL with the?WSDLsuffix (e.g.,incident.do?WSDL).
Show less
Key Features
- Extended Query Parameters: These allow filtering, ordering, limiting, and customizing SOAP query results when using functions like
get,getKeys, andgetRecords. Parameters includeencodedqueryfor filtering,orderbyandorderbydescfor sorting,excludecolumnsto omit fields,limitto restrict record count, and others for paging and view specification. - Namespace Configuration: Each table’s web service WSDL uses a unique XML namespace by default (e.g.,
http://www.service-now.com/incident) to differentiate operations when clients consume multiple tables' services. This behavior is controlled by theglide.wsdl.definition.useuniquenamespaceproperty. - Schema Compatibility: By default, the WSDL schema uses
elementFormDefault="unqualified", which can cause parsing issues for some client platforms. The propertyglide.wsdl.schema.UnqualifiedElementFormDefaultcan be set tofalseto improve compatibility with WSDL-generated clients like .NET or Axis2. - Service Name Uniqueness: Service names are unique by default to avoid conflicts, but administrators can allow duplicates by setting
glide.wsdl.uniqueservicenametofalse. - Field Value Control: Customers can limit SOAP query responses by specifying forms or excluding columns. Reference fields return sysid values, and empty SOAP parameters can clear field values in target records.
- Journal and Choice Fields: Journal entries require separate SOAP queries against the
sysjournalfieldtable. Choice fields must be referenced by their internal values, not labels, when retrieving or setting data. - Session Persistence: Clients making multiple SOAP calls in a short timeframe can persist the HTTP session to improve efficiency.
Practical Application for ServiceNow Customers
By leveraging direct web services, ServiceNow customers can integrate external systems, automate data retrieval and updates, and tailor SOAP queries with fine-grained control over returned data. Customers should ensure correct ACL configurations, understand namespace and schema settings for client compatibility, and use extended query parameters to optimize query results. This enables efficient and precise data exchange between ServiceNow and external applications.
A direct web service is available for any table in the system if the correct access control list is configured.
The supported format of the incoming message is document style literal XML SOAP documents (Document/Literal). To retrieve a direct web service WSDL description and XML schema, point to the relative URL <tablename>.do?WSDL. For example, to retrieve the WSDL for the Incident table on the online demo system, use the following URL: https://<instance name>.service-now.com/incident.do?WSDL.
Extended query parameters
| Parameter | Description | Example |
|---|---|---|
| __encoded_query | Specify an encoded query string to be used in filtering the returned results. The
encoded query string format is similar to the value that may be specified in a
sysparm_query URL parameter. See the encoded query building example in the
RSS feed generator examples. |
<__encoded_query>active=true^category='hardware'</__encoded_query> |
| __order_by | Instruct the returned results to be ordered by the specified field. | <__order_by>priority</__order_by> |
| __order_by_desc | Instruct the returned results to be ordered by the specified field, in descending order. | <__order_by_desc>opened_date</__order_by_desc> |
| __exclude_columns | Specify a list of comma delimited field names to exclude from the result set. | <__exclude_columns>sys_created_on,sys_created_by,caller_id,priority</__exclude_columns> |
| __limit | Limit the number of records that are returned. | <__limit>100</__limit> |
| __first_row | Instruct the results to be offset by this number of records from the beginning of the
set. When used with __last_row has the effect of querying for a window of
results. The results are inclusive of the first row number. |
<__first_row>250</__first_row> |
| __last_row | Instruct the results to be limited by this number of records from the beginning of the
set, or the __start_row value when specified. When used with
__first_row has the effect of querying for a window of results. The
results are less than the last row number, and does not include the last row. |
<__last_row>500</__last_row> |
| __use_view | Specify a Form view by name, to be used for limiting and expanding the results returned. When the form view contains deep referenced fields such as caller_id.email, this field will be returned in the result as well. | <__use_view>soap_view</__use_view> |
Direct web services namespace
Specifying a unique namespace for each table
The glide.wsdl.definition.use_unique_namespace property ensures that each table's direct web service WSDL has a unique targetNamespace attribute. This property is true by default, which requires a table's direct web service WSDL to use a targetNamespace value of http://www.service-now.com/<table name>. When false (or when the property is not present), all tables use the same targetNamespace value of http://www.service-now.com. Since all tables also share the same operation names, a web service client attempting to consume more than one ServiceNow web service would be unable to differentiate between requests between multiple tables. Using a unique targetNamespace value allows web service clients to distinguish requests between multiple tables.
For example, the direct web service WSDL for the incident table uses this targetNamepsace value:
<wsdl:definitions xmlns:soapenc= "http://schemas.xmlsoap.org/soap/encoding/"xmlns:wsdl = "http://schemas.xmlsoap.org/wsdl/"xmlns:http = "http://schemas.xmlsoap.org/wsdl/http/"xmlns:tns = "http://www.service-now.com/incident"xmlns:xsd = "http://www.w3.org/2001/XMLSchema"xmlns:mime = "http://schemas.xmlsoap.org/wsdl/mime/"xmlns:soap = "http://schemas.xmlsoap.org/wsdl/soap/"targetNamespace = "http://www.service-now.com/incident" ><wsdl:types><xsd:schema elementFormDefault = "unqualified"targetNamespace = "http://www.service-now.com/incident" >
Setting namespace requirements
ServiceNow's WSDL schema by default declares an attribute of elementFormDefault="unqualified". This attribute indicates whether or not locally declared elements must be qualified by the targetNamepsace in an instance document. If the value of this attribute is unqualified, then locally declared elements should not be qualified by the targetNamepsace. If the value of this attribute is qualified, then locally declared elements must be qualified by the targetNamepsace.
However, this is incompatible with the way clients generated from WSDL (for example, .NET, Axis2, webMethods) process the embedded schema. It removes the schema namespace as a result, making the web service response unparseable.
To overcome this compatibility issue, a boolean property called glide.wsdl.schema.UnqualifiedElementFormDefault is introduced. This property has the value of true by default. Setting it to false enables clients generated from WSDL to parse the return value of the web service invocation. You can modify this property using the Web Services properties page at .
Allowing duplicate service names
By default, service names from dynamically generated WSDL are unique and have the following format:
ServiceNow_<table name>
To allow duplicate service names, administrators can set the glide.wsdl.unique_service_name property to false. Create the property if it does not exist.